<?php
session_start();

require_once("../config/db.php");

$resultat = "";

// Netegem els valors introduïts
$registreNom = addslashes(htmlspecialchars($_POST["registreNom"]));
$registreCognoms = addslashes(htmlspecialchars($_POST["registreCognoms"]));
$registreEmail = addslashes(htmlspecialchars($_POST["registreEmail"]));
$registrePwd = addslashes(htmlspecialchars($_POST["registrePwd"]));
$registreRepPwd = addslashes(htmlspecialchars($_POST["registreRepPwd"]));

if (empty($registreNom) || empty($registreCognoms) || empty($registreEmail) || empty($registrePwd) || empty($registreRepPwd)) {
    $resultat="<br><div class=\"alert alert-danger\">No s'han omplert tots els inputs.</div>";
} elseif ($_POST['registrePwd'] !== $_POST['registreRepPwd']) {
    $resultat="<br><div class=\"alert alert-danger\">Les contrasenyes no coincideixen.</div>";
} elseif (strlen($_POST['registrePwd']) < 6) {
    $resultat="<br><div class=\"alert alert-danger\">La contrasenya no té un mínim de 6 caràcters.</div>";
} elseif (!filter_var($_POST['registreEmail'], FILTER_VALIDATE_EMAIL)) {
    $resultat="<br><div class=\"alert alert-danger\">El correu no està ben escrit.</div>";
} else {
    $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);
    if ($mysqli->connect_error) {
        $resultat="<br><div class=\"alert alert-danger\">No s'ha pogut connectar amb la base de dades (Error ".$mysqli->connect_errno.")</div>";
    }else{
        $mysqli->set_charset("utf8");
        $registreNom=mysqli_real_escape_string($mysqli,strip_tags($_POST['registreNom']));
        $registreCognoms=mysqli_real_escape_string($mysqli,strip_tags($_POST['registreCognoms']));
        $registreEmail=mysqli_real_escape_string($mysqli,strip_tags($_POST['registreEmail']));
        $registrePwd = $_POST['registrePwd'];
        $user_password_hash = password_hash($registrePwd, PASSWORD_DEFAULT);
        $sql = "SELECT * FROM usuaris WHERE usuari_email = '" . $registreEmail . "';";
        $comprova_email=$mysqli->query($sql);
        if ($comprova_email->num_rows == 1) {
            $resultat = "<br><div class=\"alert alert-danger\">Ja existeix un usuari amb aquest correu</div>";
        } else {
            $sql = "INSERT INTO usuaris (usuari_nom, usuari_cognoms, usuari_email, usuari_password_hash)
                    VALUES('" . $registreNom . "', '" . $registreCognoms . "', '" . $registreEmail  . "', '" . $user_password_hash . "');";
            $nou_usuari=$mysqli->query($sql);

            // Enviament del correu de benvinguda

            if ($nou_usuari) {
                $resultat = "<br><div class=\"alert alert-success\">La teva compta s'ha creat satisfactòriament.<br><strong>Atenció: </strong>Degut a les limitacions d'aquest servidor de proves no es podrà enviar el correu de benvinguda localitzat a mail/benvinguda/benvinguda.php.</div>";

                /*
                date_default_timezone_set('Europe/Madrid');
                require 'phpmailer/PHPMailerAutoload.php';
                $mail = new PHPMailer;
                $mail->isSMTP();
                $mail->SMTPDebug = 2;
                $mail->Debugoutput = 'html';
                $mail->Host = "smtp.evenzy.com";
                $mail->Port = 25;
                $mail->SMTPAuth = true;
                $mail->Username = "noreply@evenzy.com";
                $mail->Password = "XXXXXXXXXX"; // Cal introduïr el password
                $mail->setFrom('noreply@evenzy.com', 'Evenzy');
                $mail->addAddress($registreEmail, $registreNom.' '.$registreCognoms);
                $mail->Subject = 'Benvingut a Evenzy';
                $mail->msgHTML(file_get_contents('../mail/benvinguda/benvinguda.php'), dirname(__FILE__));

                if (!$mail->send()) {
                    $resultat = "<br><div class=\"alert alert-danger\">mailerror: ".$mail->ErrorInfo."</div>";
                } else {
                    $resultat = "<br><div class=\"alert alert-danger\">Emailsend</div>";
                }
                */
            } else {
                $resultat = "<br><div class=\"alert alert-danger\">El registre ha fallat. Intenta-ho més tard.</div>";
            }
        }
    }
}
echo $resultat;