// http://codepen.io/anon/pen/OyaJMa
var c = document.getElementById("canvas");
var finestra =document.getElementsByTagName("body")[0];
var ctx = c.getContext("2d");
var sobre = {
    amplada: 459,
    alcada: 243
}

function resize() {
    // Obtenim la mida del canvas
    var box = c.getBoundingClientRect();
    c.width = box.width;
    c.height = box.height;
}

// Inicialitzem la llum
var light = {
    x: 200,
    y: 0
}

function drawImatge() {
    // Prevenim imatges borroses
    ctx['imageSmoothingEnabled'] = false;
    ctx['mozImageSmoothingEnabled'] = false;
    ctx['oImageSmoothingEnabled'] = false;
    ctx['webkitImageSmoothingEnabled'] = false;
    ctx['msImageSmoothingEnabled'] = false;  

    var image = new Image();
    image.src = "http://evenzy.com/img/welcome.png";
    ctx.drawImage(image, (c.width/2)-232, (c.height/2)-195.5, 464, 391);

}

function Box() {
    this.half_size = Math.floor((1 * 50) + 1);
    //centrem
    this.x = c.width/2;
    this.y = c.height/2;
    this.shadow_length = 2000;
    this.color = "#4f4ed2";
  
    this.getDots = function() {

        var full = (Math.PI * 2) / 4;


        var p1 = {
            x: (c.width/2)-226 + 0,
            y: (c.height/2)-48 + 0
        };
        var p2 = {
            x: (c.width/2)-226 + 0,
            y: (c.height/2)-48 + 242
        };
        var p3 = {
            x: (c.width/2)-226 + 456,
            y: (c.height/2)-48 + 242
        };
        var p4 = {
            x: (c.width/2)-226 + 456,
            y: (c.height/2)-48 + 0
        };
        var p5 = {
            x: (c.width/2)-226 + 225,
            y: (c.height/2)-48 - 147
        };

        return {
            p1: p1,
            p2: p2,
            p3: p3,
            p4: p4,
            p5: p5
        };
    }
    this.draw = function() {
        var dots = this.getDots();
        ctx.beginPath();
        ctx.moveTo(dots.p1.x, dots.p1.y);
        ctx.lineTo(dots.p2.x, dots.p2.y);
        ctx.lineTo(dots.p3.x, dots.p3.y);
        ctx.lineTo(dots.p4.x, dots.p4.y);
        ctx.lineTo(dots.p5.x, dots.p5.y);
        ctx.fillStyle = this.color;
        ctx.fill();


        if (this.y - this.half_size > c.height) {
            this.y -= c.height + 100;
        }
        if (this.x - this.half_size > c.width) {
            this.x -= c.width + 100;
        }
    }
    this.drawShadow = function() {
        var dots = this.getDots();
        var angles = [];
        var points = [];

        for (dot in dots) {
            var angle = Math.atan2(light.y - dots[dot].y, light.x - dots[dot].x );
            var endX = dots[dot].x + this.shadow_length * Math.sin(-angle - Math.PI / 2);
            var endY = dots[dot].y + this.shadow_length * Math.cos(-angle - Math.PI / 2);
            angles.push(angle);
            points.push({
                endX: endX,
                endY: endY,
                startX: dots[dot].x,
                startY: dots[dot].y
            });
        };

        for (var i = points.length - 1; i >= 0; i--) {
            var n = i == 4 ? 0 : i + 1;
            ctx.beginPath();
            ctx.moveTo(points[i].startX, points[i].startY);
            ctx.lineTo(points[n].startX, points[n].startY);
            ctx.lineTo(points[n].endX, points[n].endY);
            ctx.lineTo(points[i].endX, points[i].endY);

            var gradient = ctx.createLinearGradient(points[0].startX+200,points[0].startY,points[0].endX,points[0].endY);
            gradient.addColorStop(0, "#4b4ac8");
            gradient.addColorStop(0.3, "#5457da");
            ctx.fillStyle = gradient;
            //ctx.fillStyle = "#4f4ed2";
            ctx.fill();
        };
    }
}

var boxes = [];

function draw() {
    ctx.clearRect(0, 0, c.width, c.height);
    

    for (var i = 0; i < boxes.length; i++) {
        boxes[i].drawShadow();
    };
    for (var i = 0; i < boxes.length; i++) {
        boxes[i].draw();
    };
    drawImatge();
    requestAnimationFrame(draw);

}

resize();
draw();

while (boxes.length < 1) {
    boxes.push(new Box());
}

window.onresize = resize;
finestra.onmousemove = function(e) {
    light.x = e.clientX;
    light.y = e.clientY;
}

